// Code generated by https://github.com/gagliardetto/anchor-go. DO NOT EDIT.

package khronos

import (
	"fmt"
	ag_binary "github.com/gagliardetto/binary"
	ag_solanago "github.com/gagliardetto/solana-go"
)

type Vault struct {
	Authority       ag_solanago.PublicKey
	DepositMint     ag_solanago.PublicKey
	DestinationMint ag_solanago.PublicKey
	Period          uint8
	Percentil       uint8
	DepositBump     uint8
	DestinationBump uint8
	InitialAmount   uint64
	IsActive        bool
}

var VaultDiscriminator = [8]byte{211, 8, 232, 43, 2, 152, 117, 119}

func (obj Vault) MarshalWithEncoder(encoder *ag_binary.Encoder) (err error) {
	// Write account discriminator:
	err = encoder.WriteBytes(VaultDiscriminator[:], false)
	if err != nil {
		return err
	}
	// Serialize `Authority` param:
	err = encoder.Encode(obj.Authority)
	if err != nil {
		return err
	}
	// Serialize `DepositMint` param:
	err = encoder.Encode(obj.DepositMint)
	if err != nil {
		return err
	}
	// Serialize `DestinationMint` param:
	err = encoder.Encode(obj.DestinationMint)
	if err != nil {
		return err
	}
	// Serialize `Period` param:
	err = encoder.Encode(obj.Period)
	if err != nil {
		return err
	}
	// Serialize `Percentil` param:
	err = encoder.Encode(obj.Percentil)
	if err != nil {
		return err
	}
	// Serialize `DepositBump` param:
	err = encoder.Encode(obj.DepositBump)
	if err != nil {
		return err
	}
	// Serialize `DestinationBump` param:
	err = encoder.Encode(obj.DestinationBump)
	if err != nil {
		return err
	}
	// Serialize `InitialAmount` param:
	err = encoder.Encode(obj.InitialAmount)
	if err != nil {
		return err
	}
	// Serialize `IsActive` param:
	err = encoder.Encode(obj.IsActive)
	if err != nil {
		return err
	}
	return nil
}

func (obj *Vault) UnmarshalWithDecoder(decoder *ag_binary.Decoder) (err error) {
	// Read and check account discriminator:
	{
		discriminator, err := decoder.ReadTypeID()
		if err != nil {
			return err
		}
		if !discriminator.Equal(VaultDiscriminator[:]) {
			return fmt.Errorf(
				"wrong discriminator: wanted %s, got %s",
				"[211 8 232 43 2 152 117 119]",
				fmt.Sprint(discriminator[:]))
		}
	}
	// Deserialize `Authority`:
	err = decoder.Decode(&obj.Authority)
	if err != nil {
		return err
	}
	// Deserialize `DepositMint`:
	err = decoder.Decode(&obj.DepositMint)
	if err != nil {
		return err
	}
	// Deserialize `DestinationMint`:
	err = decoder.Decode(&obj.DestinationMint)
	if err != nil {
		return err
	}
	// Deserialize `Period`:
	err = decoder.Decode(&obj.Period)
	if err != nil {
		return err
	}
	// Deserialize `Percentil`:
	err = decoder.Decode(&obj.Percentil)
	if err != nil {
		return err
	}
	// Deserialize `DepositBump`:
	err = decoder.Decode(&obj.DepositBump)
	if err != nil {
		return err
	}
	// Deserialize `DestinationBump`:
	err = decoder.Decode(&obj.DestinationBump)
	if err != nil {
		return err
	}
	// Deserialize `InitialAmount`:
	err = decoder.Decode(&obj.InitialAmount)
	if err != nil {
		return err
	}
	// Deserialize `IsActive`:
	err = decoder.Decode(&obj.IsActive)
	if err != nil {
		return err
	}
	return nil
}
